/*****************************************************************************/
/*   18F2550 Application Demo for usage of MCHPUSB Bootloader                */
/*                                                                           */
/*   Author:   Christian Stadler   , spremembe Slavko Murko                  */
/*                                   MERILNIK TEMPERATURE                    */
/*   Date:     18.08.2010            6.12.2011                              */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
#pragma case                     /* make compiler case sensitive */
#include <18F2550.h>          //nastavitve za na mikro
#device adc=10            //imamo 10 bitni ADC
#use delay(clock=48000000)  /* 20 MHz iz kvarca se preko PLL dvigne (HSPLL) na system clock  48 MHz */
/*----DODATEK PRI UPORABI BOOTLOADERJA-------------------------------------------------------------------------*/
#build (reset=0x800, interrupt=0x808)   //premik reset in inerrupt vektorjev zaradi prednaloenega Bootloaderja
#org 0, 0x7FF {}                        //Bootloader je naloen nna naslovih od 0 do 0x7FF,
                                        // zaetni naslov naega programa je lahko na 0x800
/*-------------------------------------------------------------------------------------------------------------*/


//  DEFINIRANI PINI KJER JE PRIKLJUEN LCD
#define LCD_DB4   PIN_B4
#define LCD_DB5   PIN_B5
#define LCD_DB6   PIN_B6
#define LCD_DB7   PIN_B7
#define LCD_RS    PIN_B2
#define LCD_E     PIN_B3
#define lcd_type 0        // 0=5x7, 1=5x10, 2=2 lines
#include "flex_lcd.c"
#define	TOUCH_PIN	PIN_A1
#include "ds1820.c"

void main()
{
signed long ad_temp_vrednost;
float temperatura;

         setup_wdt(WDT_ON);
         lcd_init();  // Aktiviranje LCD-ja

         printf(lcd_putc,"Temperatura:");
         delay_ms(2000);


         while(1)
            {
            restart_wdt();
         	if ( Start_meritve_ds1820() == FALSE )
               {
               printf(lcd_putc,"\rErr: DS1820 fail");
               delay_ms(2000);
               }
				while ( Konec_meritve_ds1820() == FALSE ) //akanje da bo sonda iznerila temperaturo (njen ADC)
               {
               output_high(PIN_B0);    //medtem utripanje
               delay_ms(50);
               output_low(PIN_B0);
               delay_ms(50);
               }

			   ad_temp_vrednost = Beri_temp_ds1820();
	
            temperatura=0.5*ad_temp_vrednost+0.001;
            printf(lcd_putc,"\rADC=%ld T=%03.1fC    ",ad_temp_vrednost,temperatura);

            delay_ms(1000);
            }
}
