/*****************************************************************************************/
/* R U T I N E _ Z A _ D E L O _ Z _ T E M P A R A T U R N O _ S O N D O _
   D S _ 1 8 2 0 */
/*****************************************************************************************/
//Original od Premzel Brankota okoli leta 1995  ----- Spreminjal Slavko Murko dec 2011

#define DS1820_SINGLE  //e je na vodilu samo ena sonda


BYTE	CRC_vsota;  //globalna spremenljivka
//#include "touch.icp"
#include <touch.c>

#ifndef DS1820_SINGLE //pri single TEGA NE RABIM ZA MERJENJE TEMPERATURE ZATO SEM VREGEL VEN
void	Poslji_rom_kodo(BYTE ee_adr_rom_kode) { //PRISOTEN JE LAHKO SAMO EN DS1820 MED BRANJEM KODE
//polje 64 bitov(8-famili code,48-serial number,8-CRC) iz EEPROM-a v 8 lokacijah


BYTE	i;
			for (i=0;i<=7;++i) { //polji 8 bajtov v katerih je tudi CRC
#if PIC == 84
				touch_write_byte(read_eeprom(ee_adr_rom_kode));
#else
				touch_write_byte(read_ext_eeprom(ee_adr_rom_kode));
#endif
				++ee_adr_rom_kode;
				}
			}


BYTE	Beri_rom_kodo(BYTE ee_adr_rom_kode) { //PRISOTEN JE LAHKO SAMO EN DS1820 MED BRANJEM KODE
//tota rutina naj prebere 64 bitov(8-famili code,48-serial number,8-CRC)
// in jih skrani v EEPROM v 8 lokacijah od vhodnega prar. ee_adr dalje.
//	e ni tuch_prezent ali e CRC na koncu ni 0 vrne FALSE.

BYTE	i;
			if (!touch_present()) goto neusp_exit;  //reset in preverjanje present
			touch_write_byte(0x33); //komanda beri rom kodo
			CRC_vsota = 0;	//zaetna vrednost, pozneje jo spreminja touch_read_byte
			for (i=0;i<=7;++i) { //beri e 8 bajtov v katerih je tudi CRC,na koncu mora biti CRC_vsota == 0
#if PIC == 84
				write_eeprom(ee_adr_rom_kode,touch_read_byte());
#else
				write_ext_eeprom(ee_adr_rom_kode,touch_read_byte());
#endif
				++ee_adr_rom_kode;
				}
			touch_present();	  //reset vodila
			if (CRC_vsota)			//napaka, CRC ni 0
neusp_exit:										 //e ni dallasa ali e v 1s ni uspenega prenosa javi z to kodo
				return(FALSE);
			return (TRUE);  //CRC je OK
			}
#endif

#ifdef DS1820_SINGLE
long	Beri_temp_ds1820(void) {
#else
long	Beri_temp_ds1820(BYTE ee_adr_rom_kode) {
#endif
//tota rutina naj sprejma samo prva dva bajta v globalno Temp ostale pa naj
//	sprejema na slepo samo zaradi izrauna CRC , ki ga vrne (0 je vse vredu)
//novo ime Beri_temp vsebuje naj tudi reset in skip rom.
long int	temp_ds1820; //to vrednost vraa Beri_temp_ds1820
BYTE	i;
			if (!touch_present()) goto neusp_exit;  //reset in preverjanje present
#ifdef DS1820_SINGLE
			touch_write_byte(0xCC); //skip ROM-e je samo en na vodilu ni poreben naslov
#else
			touch_write_byte(0x55); //komanda match rom, sledi ji rom koda naslovljenega Ds1820
			Poslji_rom_kodo(ee_adr_rom_kode);  //polje kodo ustreznega ds-a, iz EEPROMA
#endif
			touch_write_byte(0xBE); //komanda beri ram
			CRC_vsota = 0;	//zaetna vrednost, pozneje jo spreminja touch_read_byte
			(BYTE)temp_ds1820  = touch_read_byte(); //temp LSB
			*(&temp_ds1820+1)  = touch_read_byte(); //temp MSB
			for (i=0;i<=6;++i) { //beri e 7 bajtov v katerih je tudi CRC,na koncu mora biti CRC_vsota == 0
				touch_read_byte();
				}
			touch_present();	  //reset vodila
			if (CRC_vsota)			//napaka, CRC ni 0
neusp_exit:										 //e ni dallasa ali eni uspenega prenosa javi z to kodo
				return(0x8000);   //e je napaka pri branju vrene 0x8000 kar je -32000 kor error kodo
			return (temp_ds1820);  //CRC je OK
			}


BOOLEAN Konec_meritve_ds1820(void) {
         //return ((touch_read_byte() == 0xFF) || (stot_sek_ds1820 == 0));  //akaj na konec pretvorbe, ali poakaj najve 05.s
			return (touch_read_byte() == 0xFF); //vrne TRUE ko je konec ad pretvorbe

			}

#ifdef DS1820_SINGLE
BOOLEAN Start_meritve_ds1820(void) {
#else
BOOLEAN Start_meritve_ds1820(BYTE ee_adr_rom_kode) {
#endif
//Tudi Start_meritve naj bo brez zakasnitve, in naj vrne false,e ni vse vredu
			if (!touch_present()) return(FALSE);   //reset in preverjanje present
#ifdef DS1820_SINGLE
			touch_write_byte(0xCC); //skip ROM-e je samo en na vodilu ni poreben naslov
#else
			touch_write_byte(0x55); //komanda match rom, sledi ji rom koda naslovljenega Ds1820
			Poslji_rom_kodo(ee_adr_rom_kode);  //polje kodo ustreznega ds-a, iz EEPROMA
#endif
			touch_write_byte(0x44); //Convert T- zani z merjenjem tempetature
// tega sedaj ne rabim ker ne delam na as			stot_sek_ds1820=50;
			return(TRUE);
			}


